Coin: SoEngine Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | List of all members
SoEngine Class Referenceabstract
Engine Classes

SoEngine is the base class for Coin engines. More...

`#include <Inventor/engines/SoEngine.h>`

Inheritance diagram for SoEngine:

## Public Member Functions
void | evaluateWrapper (void)
virtual int | getOutputs (SoEngineOutputList &l) const
SoEngineOutput * | getOutput (const SbName &outputname) const
SbBool | getOutputName (const SoEngineOutput *output, SbName &outputname) const
virtual const SoEngineOutputData * | getOutputData (void) const =0
SbBool | isNotifying (void) const
virtual void | notify (SoNotList *nl)
SoEngine * | copy (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
SbBool | shouldCopy (void) const
virtual void | writeInstance (SoOutput *out)
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual const SoFieldData * | getFieldData (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
virtual SoType | getTypeId (void) const =0
| Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
virtual void | startNotify (void)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static SoEngine * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoEngineList &el)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions
| SoEngine (void)
virtual | ~SoEngine (void)
virtual void | evaluate (void)=0
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | inputChanged (SoField *which)
void | writeOutputTypes (SoOutput *out)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getInputDataPtr (void)
static const SoEngineOutputData ** | getOutputDataPtr (void)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Public Attributes inherited from SoBase
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Detailed Description

SoEngine is the base class for Coin engines.

Engines enable the application programmers to make complex connections between fields.

The most common cases where you use engines are: 1) to constrain the values of a field with regard to the contents of one or more other fields in the scene graph, 2) as a convenient way to animate parts of the scene graph.

The reference count of an engine will be increased by 1 for each connection made to one of its engine outputs, and decreased by one for a disconnect. See SoEngineOutput::addConnection() and SoEngineOutput::removeConnection(). When the reference count goes down to zero, the engine will automatically be destroyed, and subsequent attempts at using the engine will lead to a crash.

If you want complete control over when an engine gets destructed, use SoBase::ref() and SoBase::unref() for explicit referencing/dereferencing.

## Constructor & Destructor Documentation

## ◆ SoEngine()

SoEngine::SoEngine | ( | void |  | ) |
| protected

Default constructor.

## ◆ ~SoEngine()

SoEngine::~SoEngine | ( | void |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ initClasses()

void SoEngine::initClasses | ( | void |  | ) |
| static

Initializes all engines. Automatically called from SoEngine::initClass() upon initialization of Coin.

## ◆ evaluateWrapper()

void SoEngine::evaluateWrapper | ( | void |  | ) |

Triggers an engine evaluation.

## ◆ getOutputs()

int SoEngine::getOutputs | ( | SoEngineOutputList & | l | ) | const
| virtual

Adds all outputs to list. Returns the number of outputs added to the list.

## ◆ getOutput()

SoEngineOutput * SoEngine::getOutput | ( | const SbName & | outputname | ) | const

Returns the output with name outputname, or `NULL` if no such output exists.

## ◆ getOutputName()

SbBool SoEngine::getOutputName | ( | const SoEngineOutput * | output,
|  | SbName & | outputname ) const

Sets outputname to the name of output. Returns `FALSE` if no such output is contained within the engine instance.

## ◆ getOutputData()

virtual const SoEngineOutputData * SoEngine::getOutputData | ( | void |  | ) | const
| pure virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implemented in SoBoolOperation, SoCalculator, SoComposeMatrix, SoComposeRotation, SoComposeRotationFromTo, SoComposeVec2f, SoComposeVec3f, SoComposeVec4f, SoComputeBoundingBox, SoConcatenate, SoCounter, SoDecomposeMatrix, SoDecomposeRotation, SoDecomposeVec2f, SoDecomposeVec3f, SoDecomposeVec4f, SoElapsedTime, SoFieldConverter, SoGate, SoHeightMapToNormalMap, SoInterpolate, SoInterpolateFloat, SoInterpolateRotation, SoInterpolateVec2f, SoInterpolateVec3f, SoInterpolateVec4f, SoOneShot, SoOnOff, SoProfilerTopEngine, SoSelectOne, SoTexture2Convert, SoTimeCounter, SoTransformVec3f, and SoTriggerAny.

## ◆ getByName() [1/2]

SoEngine * SoEngine::getByName | ( | const SbName & | name | ) |
| static

Returns the engine named name, or `NULL` if no such engine exists. If several engines have been registered under the same name, returns the last one which was registered.

## ◆ getByName() [2/2]

int SoEngine::getByName | ( | const SbName & | name,
|  | SoEngineList & | el )
| static

Finds all engines named name. Returns the number of engines added to the el list.

## ◆ isNotifying()

SbBool SoEngine::isNotifying | ( | void |  | ) | const

Returns whether we're in a notification process. This is needed to avoid double notification when an engine enables outputs during inputChanged().

## ◆ notify()

void SoEngine::notify | ( | SoNotList * | l | ) |
| virtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoFieldContainer.

## ◆ copy()

SoEngine * SoEngine::copy | ( | void |  | ) | const

Make a duplicate of this engine and return a pointer to the duplicate.

Connections are shallow copied, i.e. the node or engine instance at the other end of the connection is not cloned. We just let the connection reference from the cloned engine refer to the same instance as the engine we've cloned ourselves from.

Note that this is not the function the application programmer should override if she needs some special behavior during a copy operation (like copying the value of internal data not exposed as fields). For that purpose, override the copyContents() method. Your overridden copyContents() method should then both copy internal data as well as calling the parent superclass' copyContents() method for automatically handling of fields and other common data.

## ◆ copyThroughConnection()

SoFieldContainer * SoEngine::copyThroughConnection | ( | void |  | ) | const
| virtual

Return copy of this instance.

Note: default implementation just returns `this` pointer, SoNode and SoEngine overrides this method to return the pointer to the actual copy.

Reimplemented from SoFieldContainer.

## ◆ shouldCopy()

SbBool SoEngine::shouldCopy | ( | void |  | ) | const

Returns whether this engine should be copied or simply referenced in a copy operation.

Engines which are not really part of the scene graph should not be copied.

## ◆ writeInstance()

void SoEngine::writeInstance | ( | SoOutput * | out | ) |
| virtual

Writes all the fields contained in this instance to the output stream within out.

This method is solely called from the write methods of fields.

Either from SoField if the write is done because of a field-to-field connection, or from one of the fields which may actually write SoFieldContainer instances, i.e. SoSFNode, SoMFNode, SoSFEngine, SoMFEngine, SoSFPath and SoMFPath.

This method, in addition to the ordinary write() method of SoNode, needs to be present since the fields don't have a write action instance in their writeValue() method, and writeInstance() will create a new SoWriteAction and call continueToApply() on it.

Reimplemented from SoFieldContainer.

Reimplemented in SoElapsedTime, and SoTimeCounter.

## ◆ evaluate()

virtual void SoEngine::evaluate | ( | void |  | ) |
| protectedpure virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implemented in SoHeightMapToNormalMap, and SoProfilerTopEngine.

## ◆ readInstance()

SbBool SoEngine::readInstance | ( | SoInput * | in,
|  | unsigned short | flags )
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoFieldContainer.

## ◆ inputChanged()

void SoEngine::inputChanged | ( | SoField * | which | ) |
| protectedvirtual

Called when an input is changed. The default method does nothing, but subclasses may override this method to do The Right Thing when a specific field is changed.

Reimplemented in SoCalculator, SoGate, SoHeightMapToNormalMap, and SoTimeCounter.

## ◆ getInputDataPtr()

const SoFieldData ** SoEngine::getInputDataPtr | ( | void |  | ) |
| staticprotected

Returns the SoFieldData class which holds information about inputs in this engine.

## ◆ getOutputDataPtr()

const SoEngineOutputData ** SoEngine::getOutputDataPtr | ( | void |  | ) |
| staticprotected

Returns the SoEngineOutputData class which holds information about the outputs in this engine.

## ◆ writeOutputTypes()

void SoEngine::writeOutputTypes | ( | SoOutput * | out | ) |
| protected

Writes the types of engine outputs for extension engines (i.e. engines not built in to Coin).

The documentation for this class was generated from the following files:

- SoEngine.h
- SoEngine.cpp